import psycopg2
import datetime
import os
remConn = psycopg2.connect("dbname=" + os.environ["RP_DBNAME"] + " user=" + os.environ["RP_USER"] + " password=" + os.environ["RP_PASSWORD"] + " host=" + os.environ["RP_HOST"])
remCur = remConn.cursor()
#Create a temporary good ip table
remCur.execute("""CREATE TEMPORARY TABLE good_ip AS
(SELECT DISTINCT ip_addr FROM ping WHERE ping_ploss >= 0 AND ping_ploss < 100)
UNION
(SELECT DISTINCT ip_addr FROM topology WHERE t_status = 'C')""")
#Vsetky data od jan 2009 do dec 2021
#Zistime avg ping z najnovsieho mesiaca pre kazde useky + pomer, kde baseline (1) bude najstarsi mesiac

#WITH relevant_ip AS (SELECT h.ip_addr FROM good_ip g JOIN hosts h ON g.ip_addr = h.ip_addr WHERE EXTRACT(month FROM h.enter_date) = 1 AND EXTRACT(year FROM h.enter_date) = 2009 AND NOT(h.ip_addr <<= '0.0.0.0/8' OR h.ip_addr <<= '0.0.0.0/32' OR h.ip_addr <<= '10.0.0.0/8' OR h.ip_addr <<= '100.64.0.0/10' OR h.ip_addr <<= '127.0.0.0/8' OR h.ip_addr <<= '169.254.0.0/16' OR h.ip_addr <<= '172.16.0.0/12' OR h.ip_addr <<= '192.0.2.0/24' OR h.ip_addr <<= '192.88.99.0/24' OR h.ip_addr <<= '192.88.99.2/32' OR h.ip_addr <<= '192.168.0.0/16' OR h.ip_addr <<= '192.0.0.0/24' OR h.ip_addr <<= '198.18.0.0/15' OR h.ip_addr <<= '198.51.100.0/24' OR h.ip_addr <<= '203.0.113.0/24' OR h.ip_addr <<= '255.255.255.255/32')) SELECT AVG(p.ping_rttmin), AVG(p.ping_rttavg), AVG(p.ping_rttmax) FROM relevant_ip r JOIN ping p ON r.ip_addr = p.ip_addr AND p.ping_date >= '2009-12-01' AND p.ping_date <= '2009-12-31' AND p.ping_ploss >= 0 AND p.ping_ploss < 100
min_data = []
avg_data = []
max_data = []
min_baseline = []
avg_baseline = []
max_baseline = []
with open("output.txt", "w") as o:
	for k in range(13):
		min_data.append([])
		avg_data.append([])
		max_data.append([])
		min_baseline.append([])
		avg_baseline.append([])
		max_baseline.append([])
		for i in range(1, 13):
			remCur.execute("""WITH relevant_ip AS (SELECT h.ip_addr FROM good_ip g JOIN hosts h ON g.ip_addr = h.ip_addr WHERE EXTRACT(month FROM h.enter_date) = """ + str(i) + """ AND EXTRACT(year FROM h.enter_date) = """ + str(2009 + k) + """
		AND NOT(h.ip_addr <<= '0.0.0.0/8' OR h.ip_addr <<= '0.0.0.0/32' OR h.ip_addr <<= '10.0.0.0/8'
			OR h.ip_addr <<= '100.64.0.0/10' OR h.ip_addr <<= '127.0.0.0/8' OR h.ip_addr <<=
			'169.254.0.0/16' OR h.ip_addr <<= '172.16.0.0/12' OR h.ip_addr <<= '192.0.2.0/24' OR h.ip_addr <<= '192.88.99.0/24'
			OR h.ip_addr <<= '192.88.99.2/32' OR h.ip_addr <<= '192.168.0.0/16' OR h.ip_addr <<= '192.0.0.0/24'
			OR h.ip_addr <<= '198.18.0.0/15' OR h.ip_addr <<= '198.51.100.0/24' OR h.ip_addr <<= '203.0.113.0/24'
			OR h.ip_addr <<= '255.255.255.255/32'))
			SELECT AVG(p.ping_rttmin), AVG(p.ping_rttavg), AVG(p.ping_rttmax) FROM relevant_ip r JOIN ping p ON r.ip_addr = p.ip_addr AND p.ping_date >= '2021-12-01' AND p.ping_date <= '2021-12-31' AND p.ping_ploss >= 0 AND p.ping_ploss < 100""")
			data = remCur.fetchone()
			min_data[k].append(data[0])
			avg_data[k].append(data[1])
			max_data[k].append(data[2])
			min_baseline[k].append(min_data[k][i - 1] / min_data[0][0])
			avg_baseline[k].append(avg_data[k][i - 1] / avg_data[0][0])
			max_baseline[k].append(max_data[k][i - 1] / max_data[0][0])
			o.write(str(i) + "/" + str(2009 + k) + ":\nMin = " + str(min_data[k][i - 1]) + " Baseline = "  + str(min_baseline[k][i - 1]) + "\n")
			o.write(str(i) + "/" + str(2009 + k) + ":\nAvg = " + str(avg_data[k][i - 1]) + " Baseline = "  + str(avg_baseline[k][i - 1]) + "\n")
			o.write(str(i) + "/" + str(2009 + k) + ":\nMax = " + str(max_data[k][i - 1]) + " Baseline = "  + str(max_baseline[k][i - 1]) + "\n")
